"""Javascript helpers."""

import typing as t

from typing_extensions import NotRequired, TypedDict


class Events(TypedDict):
    """Event handlers."""

    abort: NotRequired[t.Union[str, t.Callable]]
    afterprint: NotRequired[t.Union[str, t.Callable]]
    animationend: NotRequired[t.Union[str, t.Callable]]
    animationiteration: NotRequired[t.Union[str, t.Callable]]
    animationstart: NotRequired[t.Union[str, t.Callable]]
    beforeprint: NotRequired[t.Union[str, t.Callable]]
    beforeunload: NotRequired[t.Union[str, t.Callable]]
    blur: NotRequired[t.Union[str, t.Callable]]
    canplay: NotRequired[t.Union[str, t.Callable]]
    canplaythrough: NotRequired[t.Union[str, t.Callable]]
    change: NotRequired[t.Union[str, t.Callable]]
    click: NotRequired[t.Union[str, t.Callable]]
    contextmenu: NotRequired[t.Union[str, t.Callable]]
    copy: NotRequired[t.Union[str, t.Callable]]
    cut: NotRequired[t.Union[str, t.Callable]]
    dblclick: NotRequired[t.Union[str, t.Callable]]
    drag: NotRequired[t.Union[str, t.Callable]]
    dragend: NotRequired[t.Union[str, t.Callable]]
    dragenter: NotRequired[t.Union[str, t.Callable]]
    dragleave: NotRequired[t.Union[str, t.Callable]]
    dragover: NotRequired[t.Union[str, t.Callable]]
    dragstart: NotRequired[t.Union[str, t.Callable]]
    drop: NotRequired[t.Union[str, t.Callable]]
    durationchange: NotRequired[t.Union[str, t.Callable]]
    ended: NotRequired[t.Union[str, t.Callable]]
    error: NotRequired[t.Union[str, t.Callable]]
    focus: NotRequired[t.Union[str, t.Callable]]
    focusin: NotRequired[t.Union[str, t.Callable]]
    focusout: NotRequired[t.Union[str, t.Callable]]
    fullscreenchange: NotRequired[t.Union[str, t.Callable]]
    fullscreenerror: NotRequired[t.Union[str, t.Callable]]
    hashchange: NotRequired[t.Union[str, t.Callable]]
    input: NotRequired[t.Union[str, t.Callable]]
    invalid: NotRequired[t.Union[str, t.Callable]]
    keydown: NotRequired[t.Union[str, t.Callable]]
    keypress: NotRequired[t.Union[str, t.Callable]]
    keyup: NotRequired[t.Union[str, t.Callable]]
    load: NotRequired[t.Union[str, t.Callable]]
    loadeddata: NotRequired[t.Union[str, t.Callable]]
    loadedmetadata: NotRequired[t.Union[str, t.Callable]]
    loadstart: NotRequired[t.Union[str, t.Callable]]
    message: NotRequired[t.Union[str, t.Callable]]
    mousedown: NotRequired[t.Union[str, t.Callable]]
    mouseenter: NotRequired[t.Union[str, t.Callable]]
    mouseleave: NotRequired[t.Union[str, t.Callable]]
    mousemove: NotRequired[t.Union[str, t.Callable]]
    mouseover: NotRequired[t.Union[str, t.Callable]]
    mouseout: NotRequired[t.Union[str, t.Callable]]
    mouseup: NotRequired[t.Union[str, t.Callable]]
    mousewheel: NotRequired[t.Union[str, t.Callable]]
    offline: NotRequired[t.Union[str, t.Callable]]
    online: NotRequired[t.Union[str, t.Callable]]
    open: NotRequired[t.Union[str, t.Callable]]
    pagehide: NotRequired[t.Union[str, t.Callable]]
    pageshow: NotRequired[t.Union[str, t.Callable]]
    paste: NotRequired[t.Union[str, t.Callable]]
    pause: NotRequired[t.Union[str, t.Callable]]
    play: NotRequired[t.Union[str, t.Callable]]
    playing: NotRequired[t.Union[str, t.Callable]]
    popstate: NotRequired[t.Union[str, t.Callable]]
    progress: NotRequired[t.Union[str, t.Callable]]
    ratechange: NotRequired[t.Union[str, t.Callable]]
    resize: NotRequired[t.Union[str, t.Callable]]
    reset: NotRequired[t.Union[str, t.Callable]]
    scroll: NotRequired[t.Union[str, t.Callable]]
    search: NotRequired[t.Union[str, t.Callable]]
    seeked: NotRequired[t.Union[str, t.Callable]]
    seeking: NotRequired[t.Union[str, t.Callable]]
    select: NotRequired[t.Union[str, t.Callable]]
    show: NotRequired[t.Union[str, t.Callable]]
    stalled: NotRequired[t.Union[str, t.Callable]]
    storage: NotRequired[t.Union[str, t.Callable]]
    submit: NotRequired[t.Union[str, t.Callable]]
    suspend: NotRequired[t.Union[str, t.Callable]]
    timeupdate: NotRequired[t.Union[str, t.Callable]]
    toggle: NotRequired[t.Union[str, t.Callable]]
    touchcancel: NotRequired[t.Union[str, t.Callable]]
    touchend: NotRequired[t.Union[str, t.Callable]]
    touchmove: NotRequired[t.Union[str, t.Callable]]
    touchstart: NotRequired[t.Union[str, t.Callable]]
    transitionend: NotRequired[t.Union[str, t.Callable]]
    unload: NotRequired[t.Union[str, t.Callable]]
    volumechange: NotRequired[t.Union[str, t.Callable]]
    waiting: NotRequired[t.Union[str, t.Callable]]
    wheel: NotRequired[t.Union[str, t.Callable]]
